Differences between revisions 4 and 5
Revision 4 as of 2010-08-28 02:11:32
Size: 1759
Editor: GreyCat
Comment: Answers.
Revision 5 as of 2011-08-12 12:56:10
Size: 1844
Editor: GreyCat
Comment: since exercise 2 broke in bash 4.1, we need to adjust the text a bit...
Deletions are marked like this. Additions are marked like this.
Line 17: Line 17:
These rules are extremely convoluted, and they still fail to catch even some remarkably simple cases. These rules are extremely convoluted, and they still fail to catch even some remarkably simple cases. Even worse, the rules ''change'' from one Bash version to another, as Bash attempts to track the extremely slippery POSIX definition of this "feature". When a SubShell is involved, it gets worse still -- the behavior changes depending on whether Bash is invoked in POSIX mode. [[http://fvue.nl/wiki/Bash:_Error_handling|Another wiki]] has a page that covers this in more detail. Be sure to check the caveats.
Line 29: Line 29:
''Exercise 2: why does ''this'' one appear to work?'' ''Exercise 2: why does ''this'' one sometimes appear to work?  In which versions of bash does it work, and in which versions does it fail?''
Line 41: Line 41:
Even worse, the rules ''change'' from one Bash version to another, as Bash attempts to track the extremely slippery POSIX definition of this "feature". When a SubShell is involved, it gets worse still -- the behavior changes depending on whether Bash is invoked in POSIX mode. [[http://fvue.nl/wiki/Bash:_Error_handling|Another wiki]] has a page that covers this in more detail. Be sure to check the caveats.

Why doesn't set -e (set -o errexit) do what I expected?

set -e was an attempt to add "automatic error detection" to the shell. Its goal was to cause the shell to abort any time an error occurred, so you don't have to put || exit 1 after each important command.

That goal is non-trivial, because many commands are supposed to return non-zero. For example,

  if [ -d /foo ]; then
    ...
  else
    ...
  fi

Clearly we don't want to abort when [ -d /foo ] returns non-zero (because the directory does not exist) -- our script wants to handle that in the else part. So the implementors decided to make a bunch of special rules, like "commands that are part of an if test are immune", or "commands in a pipeline, other than the last one, are immune".

These rules are extremely convoluted, and they still fail to catch even some remarkably simple cases. Even worse, the rules change from one Bash version to another, as Bash attempts to track the extremely slippery POSIX definition of this "feature". When a SubShell is involved, it gets worse still -- the behavior changes depending on whether Bash is invoked in POSIX mode. Another wiki has a page that covers this in more detail. Be sure to check the caveats.

Exercise for the reader: why doesn't this example print anything?

   1 #!/bin/bash
   2 set -e
   3 i=0
   4 let i++
   5 echo "i is $i"

Exercise 2: why does this one sometimes appear to work? In which versions of bash does it work, and in which versions does it fail?

   1 #!/bin/bash
   2 set -e
   3 i=0
   4 ((i++))
   5 echo "i is $i"

(Answers)

GreyCat's personal recommendation is simple: don't use set -e. Add your own error checking instead.

BashFAQ/105 (last edited 2021-03-11 06:07:25 by dsl-66-36-156-249)